package com.neusoft.smart.pos.inventory.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class InventoryStoreTotalExample {
    
    protected String orderByClause;
    
    protected boolean distinct;
    
    protected List<Criteria> oredCriteria;
    
    private Integer offset;
    
    private Integer limit;
    
    private Integer shopId;
    
    public InventoryStoreTotalExample() {
        oredCriteria = new ArrayList<Criteria>();
    }
    
    public String getOrderByClause() {
        return orderByClause;
    }
    
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }
    
    public boolean isDistinct() {
        return distinct;
    }
    
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }
    
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }
    
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }
    
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }
    
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }
    
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }
    
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }
    
    public Integer getOffset() {
        return this.offset;
    }
    
    public void setOffset(Integer offset) {
        this.offset = offset;
    }
    
    public Integer getLimit() {
        return this.limit;
    }
    
    public void setLimit(Integer limit) {
        this.limit = limit;
    }
    
    public InventoryStoreTotalExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }
    
    public Integer getShopId() {
        return shopId;
    }
    
    public void setShopId(Integer shopId) {
        this.shopId = shopId;
    }
    
    protected abstract static class GeneratedCriteria {
        
        protected List<Criterion> criteria;
        
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }
        
        public boolean isValid() {
            return criteria.size() > 0;
        }
        
        public List<Criterion> getAllCriteria() {
            return criteria;
        }
        
        public List<Criterion> getCriteria() {
            return criteria;
        }
        
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }
        
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }
        
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }
        
        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }
        
        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }
        
        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }
        
        public Criteria andGoodsBarCodeIsNull() {
            addCriterion("goods_bar_code is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeIsNotNull() {
            addCriterion("goods_bar_code is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeEqualTo(String value) {
            addCriterion("goods_bar_code =", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotEqualTo(String value) {
            addCriterion("goods_bar_code <>", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeGreaterThan(String value) {
            addCriterion("goods_bar_code >", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeGreaterThanOrEqualTo(String value) {
            addCriterion("goods_bar_code >=", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLessThan(String value) {
            addCriterion("goods_bar_code <", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLessThanOrEqualTo(String value) {
            addCriterion("goods_bar_code <=", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLike(String value) {
            addCriterion("goods_bar_code like", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotLike(String value) {
            addCriterion("goods_bar_code not like", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeIn(List<String> values) {
            addCriterion("goods_bar_code in", values, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotIn(List<String> values) {
            addCriterion("goods_bar_code not in", values, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeBetween(String value1, String value2) {
            addCriterion("goods_bar_code between", value1, value2, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotBetween(String value1, String value2) {
            addCriterion("goods_bar_code not between", value1, value2, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIsNull() {
            addCriterion("goods_category is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIsNotNull() {
            addCriterion("goods_category is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryEqualTo(String value) {
            addCriterion("goods_category =", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotEqualTo(String value) {
            addCriterion("goods_category <>", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryGreaterThan(String value) {
            addCriterion("goods_category >", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryGreaterThanOrEqualTo(String value) {
            addCriterion("goods_category >=", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLessThan(String value) {
            addCriterion("goods_category <", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLessThanOrEqualTo(String value) {
            addCriterion("goods_category <=", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLike(String value) {
            addCriterion("goods_category like", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotLike(String value) {
            addCriterion("goods_category not like", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIn(List<String> values) {
            addCriterion("goods_category in", values, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotIn(List<String> values) {
            addCriterion("goods_category not in", values, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryBetween(String value1, String value2) {
            addCriterion("goods_category between", value1, value2, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotBetween(String value1, String value2) {
            addCriterion("goods_category not between", value1, value2, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIdEqualTo(Integer value) {
            addCriterion("goods_category_id =", value, "goodsCategoryId");
            return (Criteria) this;
        }
        public Criteria andSupplierIsNull() {
            addCriterion("supplier is null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIsNotNull() {
            addCriterion("supplier is not null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierEqualTo(String value) {
            addCriterion("supplier =", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotEqualTo(String value) {
            addCriterion("supplier <>", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierGreaterThan(String value) {
            addCriterion("supplier >", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierGreaterThanOrEqualTo(String value) {
            addCriterion("supplier >=", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierLessThan(String value) {
            addCriterion("supplier <", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierLessThanOrEqualTo(String value) {
            addCriterion("supplier <=", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierLike(String value) {
            addCriterion("supplier like", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotLike(String value) {
            addCriterion("supplier not like", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIn(List<String> values) {
            addCriterion("supplier in", values, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotIn(List<String> values) {
            addCriterion("supplier not in", values, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierBetween(String value1, String value2) {
            addCriterion("supplier between", value1, value2, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotBetween(String value1, String value2) {
            addCriterion("supplier not between", value1, value2, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitIsNull() {
            addCriterion("unit is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitIsNotNull() {
            addCriterion("unit is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitEqualTo(String value) {
            addCriterion("unit =", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitNotEqualTo(String value) {
            addCriterion("unit <>", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitGreaterThan(String value) {
            addCriterion("unit >", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitGreaterThanOrEqualTo(String value) {
            addCriterion("unit >=", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitLessThan(String value) {
            addCriterion("unit <", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitLessThanOrEqualTo(String value) {
            addCriterion("unit <=", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitLike(String value) {
            addCriterion("unit like", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitNotLike(String value) {
            addCriterion("unit not like", value, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitIn(List<String> values) {
            addCriterion("unit in", values, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitNotIn(List<String> values) {
            addCriterion("unit not in", values, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitBetween(String value1, String value2) {
            addCriterion("unit between", value1, value2, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andGoodsUnitNotBetween(String value1, String value2) {
            addCriterion("unit not between", value1, value2, "goodsUnit");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateIsNull() {
            addCriterion("quality_date is null");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateIsNotNull() {
            addCriterion("quality_date is not null");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateEqualTo(Date value) {
            addCriterionForJDBCDate("quality_date =", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("quality_date <>", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateGreaterThan(Date value) {
            addCriterionForJDBCDate("quality_date >", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("quality_date >=", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateLessThan(Date value) {
            addCriterionForJDBCDate("quality_date <", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("quality_date <=", value, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateIn(List<Date> values) {
            addCriterionForJDBCDate("quality_date in", values, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("quality_date not in", values, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("quality_date between", value1, value2, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andQualityDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("quality_date not between", value1, value2, "qualityDate");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumIsNull() {
            addCriterion("s.storage_num is null");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumIsNotNull() {
            addCriterion("s.storage_num is not null");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumEqualTo(Integer value) {
            addCriterion("s.storage_num =", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumNotEqualTo(Integer value) {
            addCriterion("s.storage_num <>", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumGreaterThan(Integer value) {
            addCriterion("s.storage_num >", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("s.storage_num >=", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumLessThan(Integer value) {
            addCriterion("s.storage_num <", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumLessThanOrEqualTo(Integer value) {
            addCriterion("s.storage_num <=", value, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumIn(List<Integer> values) {
            addCriterion("s.storage_num in", values, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumNotIn(List<Integer> values) {
            addCriterion("s.storage_num not in", values, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumBetween(Integer value1, Integer value2) {
            addCriterion("s.storage_num between", value1, value2, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andStorageNumNotBetween(Integer value1, Integer value2) {
            addCriterion("s.storage_num not between", value1, value2, "storageNum");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceIsNull() {
            addCriterion("average_in_price is null");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceIsNotNull() {
            addCriterion("average_in_price is not null");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceEqualTo(BigDecimal value) {
            addCriterion("average_in_price =", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceNotEqualTo(BigDecimal value) {
            addCriterion("average_in_price <>", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceGreaterThan(BigDecimal value) {
            addCriterion("average_in_price >", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("average_in_price >=", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceLessThan(BigDecimal value) {
            addCriterion("average_in_price <", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("average_in_price <=", value, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceIn(List<BigDecimal> values) {
            addCriterion("average_in_price in", values, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceNotIn(List<BigDecimal> values) {
            addCriterion("average_in_price not in", values, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("average_in_price between", value1, value2, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andAverageInPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("average_in_price not between", value1, value2, "averageInPrice");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountIsNull() {
            addCriterion("total_inventory_amount is null");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountIsNotNull() {
            addCriterion("total_inventory_amount is not null");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountEqualTo(BigDecimal value) {
            addCriterion("total_inventory_amount =", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountNotEqualTo(BigDecimal value) {
            addCriterion("total_inventory_amount <>", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountGreaterThan(BigDecimal value) {
            addCriterion("total_inventory_amount >", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_inventory_amount >=", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountLessThan(BigDecimal value) {
            addCriterion("total_inventory_amount <", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_inventory_amount <=", value, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountIn(List<BigDecimal> values) {
            addCriterion("total_inventory_amount in", values, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountNotIn(List<BigDecimal> values) {
            addCriterion("total_inventory_amount not in", values, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_inventory_amount between", value1, value2, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andTotalInventoryAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_inventory_amount not between", value1, value2, "totalInventoryAmount");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeIsNull() {
            addCriterion("updated_time is null");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeIsNotNull() {
            addCriterion("updated_time is not null");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeEqualTo(Date value) {
            addCriterionForJDBCDate("updated_time =", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("updated_time <>", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeGreaterThan(Date value) {
            addCriterionForJDBCDate("updated_time >", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updated_time >=", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeLessThan(Date value) {
            addCriterionForJDBCDate("updated_time <", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updated_time <=", value, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeIn(List<Date> values) {
            addCriterionForJDBCDate("updated_time in", values, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("updated_time not in", values, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updated_time between", value1, value2, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andUpdatedTimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updated_time not between", value1, value2, "updatedTime");
            return (Criteria) this;
        }
        
        public Criteria andOperatorIsNull() {
            addCriterion("operator is null");
            return (Criteria) this;
        }
        
        public Criteria andOperatorIsNotNull() {
            addCriterion("operator is not null");
            return (Criteria) this;
        }
        
        public Criteria andOperatorEqualTo(String value) {
            addCriterion("operator =", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorNotEqualTo(String value) {
            addCriterion("operator <>", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorGreaterThan(String value) {
            addCriterion("operator >", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorGreaterThanOrEqualTo(String value) {
            addCriterion("operator >=", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorLessThan(String value) {
            addCriterion("operator <", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorLessThanOrEqualTo(String value) {
            addCriterion("operator <=", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorLike(String value) {
            addCriterion("operator like", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorNotLike(String value) {
            addCriterion("operator not like", value, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorIn(List<String> values) {
            addCriterion("operator in", values, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorNotIn(List<String> values) {
            addCriterion("operator not in", values, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorBetween(String value1, String value2) {
            addCriterion("operator between", value1, value2, "operator");
            return (Criteria) this;
        }
        
        public Criteria andOperatorNotBetween(String value1, String value2) {
            addCriterion("operator not between", value1, value2, "operator");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNull() {
            addCriterion("shop_id is null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNotNull() {
            addCriterion("shop_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("shop_id =", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("shop_id <>", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("shop_id >", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_id >=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("shop_id <", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("shop_id <=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("shop_id in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("shop_id not in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdIsNull() {
            addCriterion("supplier is null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdIsNotNull() {
            addCriterion("supplier is not null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdEqualTo(Integer value) {
            addCriterion("supplier =", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdNotEqualTo(Integer value) {
            addCriterion("supplier <>", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdGreaterThan(Integer value) {
            addCriterion("supplier >", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier >=", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdLessThan(Integer value) {
            addCriterion("supplier <", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdLessThanOrEqualTo(Integer value) {
            addCriterion("supplier <=", value, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdIn(List<Integer> values) {
            addCriterion("supplier in", values, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdNotIn(List<Integer> values) {
            addCriterion("supplier not in", values, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdBetween(Integer value1, Integer value2) {
            addCriterion("supplier between", value1, value2, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIdNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier not between", value1, value2, "supplierId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdEqualTo(Integer value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotEqualTo(Integer value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThan(Integer value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThan(Integer value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIn(List<Integer> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotIn(List<Integer> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andStatusIdEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }
    }
    
    public static class Criteria extends GeneratedCriteria {
        
        protected Criteria() {
            super();
        }
    }
    
    public static class Criterion {
        
        private String condition;
        
        private Object value;
        
        private Object secondValue;
        
        private boolean noValue;
        
        private boolean singleValue;
        
        private boolean betweenValue;
        
        private boolean listValue;
        
        private String typeHandler;
        
        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }
        
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }
        
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }
        
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }
        
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
        
        public String getCondition() {
            return condition;
        }
        
        public Object getValue() {
            return value;
        }
        
        public Object getSecondValue() {
            return secondValue;
        }
        
        public boolean isNoValue() {
            return noValue;
        }
        
        public boolean isSingleValue() {
            return singleValue;
        }
        
        public boolean isBetweenValue() {
            return betweenValue;
        }
        
        public boolean isListValue() {
            return listValue;
        }
        
        public String getTypeHandler() {
            return typeHandler;
        }
    }
}